create or replace
PROCEDURE ETL_RETRABPEND
                     (P_DTINI  IN DATE,
                      P_DTFINA IN DATE)
IS
  V_DTFIM           DATE;
  V_DTINI           DATE;
  V_CDREDUITTRAB    VARCHAR2(20);
  V_EQUIPETRAB      VARCHAR2(10);

  V_DTMES           VARCHAR2(10);
  V_DTANO           VARCHAR2(04);
  V_IDSTATUSCONT    VARCHAR2(12);
  
  V_DTMESCONCLUSAO  VARCHAR2(10);
  V_DTANOCONCLUSAO  VARCHAR2(10);
  
  V_DTMESINCLUSAO  VARCHAR2(10);
  V_DTANOINCLUSAO  VARCHAR2(10);
  

  /*CONSTANTES*/
  
  CON_CONCLUIDO     VARCHAR2(9)  := 'Concludo';
  CON_ANDAMENTO     VARCHAR2(12) := 'Em Andamento';
  CON_PENDENTE      VARCHAR2(08) := 'Pendente';
  CON_CANCELADO     VARCHAR2(09) := 'Cancelado';
  CON_INTERROMP     VARCHAR2(12) := 'Interrompido';
  CON_DESLIGADO     VARCHAR2(10) := 'Desligado';
  CON_INDEFINIDO    VARCHAR2(20) := 'Indefinido';  

BEGIN
     V_DTINI  := P_DTINI;

    V_DTMES  :=  TO_CHAR(V_DTINI,'MM');
    V_DTANO  :=  TO_CHAR(V_DTINI,'YYYY');

/*APAGA OS DADOS J EXISTENTES A PARTIR DA DATA INCIO*/
    DELETE FROM ETL_RETRAB
     WHERE CDANO >= V_DTANO
       AND CDMES >= V_DTMES;

    
    WHILE (V_DTINI  <=  P_DTFINA) LOOP

       V_DTFIM := LAST_DAY( V_DTINI);

       FOR C_ETL IN
       
          (SELECT E.CDEQUIPETRAB AS EQUIPETRAB, -- EQUIPE TRABALHO
                  OP.CDOPERADOR, -- OPERADOR DE INCLUSO
                  C.CDCLIENTE, -- NOME DO CLIENTE
                  IT.CDREDUITTRAB AS CDREDUITTRAB,
                  PV.CDPRODUTO AS NMVERSAO, -- VERSO
                  PC.NMPRODUTO AS NMSISTEMA, -- NOME NO SISTEMA
                  TO_CHAR(DTINCATIVTAR, 'YYYY') AS ANOINCLUSAO, -- Data incluso do planejamento da atividade
                  TO_CHAR(DTINCATIVTAR, 'MM') AS MESINCLUSAO, -- MS DE INCLUSO DA ATIVIDADE
                  TO_CHAR(DTCONATIVTAR, 'YYYY') AS ANOCONCLUSAO, -- ANO DE CONCLUSO DA ATIVIDADE
                  TO_CHAR(DTCONATIVTAR, 'MM') AS MESCONCLUSAO, -- MES DE CONCLUSO DA ATIVIDADE
                  PR.CDPROCESSO, -- DADOS DA TAREFA,
                  PL.IDSITATIVTAR, -- STATUS DA ATIVIDADE
                  OA.CDOPERADOR AS CDOPERRESP,
                  SUM(DECODE(PR.CDPROCESSO, 10706, 1, 10712, 1, 0)) AS QTERROTESTE, -- QTDE ERRO NO TESTE
                  SUM(DECODE(PR.CDPROCESSO, 10196, 1, 0)) AS QTERROCLIENTE, -- QTDE ERRO NO CLIENTE
                  SUM(DECODE(PR.CDPROCESSO, 10196, 1, 10706, 1, 10712, 1, 0)) AS QTERROTOTAL, -- QTDE ERRO TOTAL
                  SUM(1) AS QTTOTALATIV -- QTDE ATIVIDADE
             FROM PLANATIVTARE PL, TAREFA TR, PROCESSO PR, OPERADOR OP,
                  ITEMTRAB IT, FUNCIONARIO FU, SOLISERV SC, CLIENTE C,
                  PRODUTO PV, PRODUTO PC, EQUIPETRAB E, OPERADOR OA
            WHERE PL.CDFILIAL = TR.CDFILIAL
              AND PL.NRTAREFA = TR.NRTAREFA
              AND TR.CDFILIAL = SC.CDFILIAL
              AND TR.NRSOLISERV = SC.NRSOLISERV
              AND SC.CDCLIENTE = C.CDCLIENTE
              AND PL.CDPROCESSO = PR.CDPROCESSO
              AND PL.CDOPERRESP = OP.CDOPERADOR
              AND PL.CDOPERINCL = OA.CDOPERADOR
              AND PL.CDITEMTRAB = IT.CDITEMTRAB(+)
              AND OP.CDFUNC     = FU.CDFUNC
              AND PV.CDPRODUTO  = SC.CDPRODGRUP         
              AND PC.CDPRODUTO  = SC.CDPRODCOMP
              AND (PL.CDPROCESSO = 11045 OR PL.CDPROCESSO = 11054 OR PL.CDPROCESSO = 10196 OR
                   PL.CDPROCESSO = 10712 OR PL.CDPROCESSO = 10706 OR PL.CDPROCESSO = 11077 OR PL.CDPROCESSO = 11080)
              AND E.CDEQUIPETRAB(+) = FU.CDEQUIPETRAB
           
              AND  TO_CHAR(DTCONATIVTAR, 'YYYY')= V_DTANO
              AND  TO_CHAR(DTCONATIVTAR, 'mm')= V_DTMES
           

          
        GROUP BY 
                  E.CDEQUIPETRAB, -- EQUIPE TRABALHO
                  OP.CDOPERADOR, -- OPERADOR DE INCLUSO
                  C.CDCLIENTE, -- NOME DO CLIENTE
                  IT.CDREDUITTRAB,
                  PV.CDPRODUTO , -- VERSO
                  PC.NMPRODUTO, -- NOME NO SISTEMA
                  TO_CHAR(DTINCATIVTAR, 'YYYY'), -- Data incluso do planejamento da atividade
                  TO_CHAR(DTINCATIVTAR, 'MM') , -- MS DE INCLUSO DA ATIVIDADE
                  TO_CHAR(DTCONATIVTAR, 'YYYY') , -- ANO DE CONCLUSO DA ATIVIDADE
                  TO_CHAR(DTCONATIVTAR, 'MM'), -- MES DE CONCLUSO DA ATIVIDADE
                  PR.CDPROCESSO, -- DADOS DA TAREFA,
                  PL.IDSITATIVTAR, -- STATUS DA ATIVIDADE
                  OA.CDOPERADOR)
       LOOP
       
            
              IF C_ETL.IDSITATIVTAR = 'C' THEN
                 V_IDSTATUSCONT := CON_CONCLUIDO;
                 ELSE IF C_ETL.IDSITATIVTAR = 'A' THEN
                         V_IDSTATUSCONT := CON_ANDAMENTO;
                         ELSE IF C_ETL.IDSITATIVTAR = 'I' THEN
                                 V_IDSTATUSCONT := CON_INTERROMP;
                            ELSE V_IDSTATUSCONT := CON_CANCELADO;
                        END IF;
                 END IF;
              END IF;  
          
              IF C_ETL.EQUIPETRAB IS NULL
                 THEN V_EQUIPETRAB:= CON_DESLIGADO;
               ELSE   V_EQUIPETRAB:= C_ETL.EQUIPETRAB ;
              END IF; 
               
              IF C_ETL.CDREDUITTRAB IS NULL
                 THEN V_CDREDUITTRAB:= CON_INDEFINIDO;
               ELSE   V_CDREDUITTRAB:= C_ETL.CDREDUITTRAB;
               END IF;
          
              IF C_ETL.ANOINCLUSAO IS NULL
                 THEN V_DTANOINCLUSAO:= CON_INDEFINIDO;
               ELSE   V_DTANOINCLUSAO:= C_ETL.ANOINCLUSAO;
              END IF;
              
              IF C_ETL.MESINCLUSAO IS NULL
                 THEN V_DTMESINCLUSAO:= CON_INDEFINIDO;
               ELSE   V_DTMESINCLUSAO:= C_ETL.MESINCLUSAO;
              END IF;
              
              V_DTMES  :=  TO_CHAR(V_DTFIM,'MM');
              V_DTANO  :=  TO_CHAR(V_DTFIM,'YYYY');

              INSERT INTO ETL_RETRAB
                      (CDEQUIPETRAB,    CDOPERADOR,        CDCLIENTE,
                       CDPRODUTO,       CDANO,             CDMES,
                       CDITEMTRAB,      CDPROCESSO,        STATUSATIV, 
                       ANOINC,          MESINC,            CDOPERRESP,
                       QTERROTESTE,     QTERROCLI,         QTERROTOTAL,
                       QTTOTALATIV
                       )

              VALUES
                      (V_EQUIPETRAB,       C_ETL.CDOPERADOR,       C_ETL.CDCLIENTE, 
                       C_ETL.NMVERSAO,     C_ETL.ANOCONCLUSAO,     C_ETL.MESCONCLUSAO,
                       V_CDREDUITTRAB,     C_ETL.CDPROCESSO,       V_IDSTATUSCONT,
                       V_DTANOINCLUSAO,    V_DTMESINCLUSAO,        C_ETL.CDOPERRESP,
                       C_ETL.QTERROTESTE,  C_ETL.QTERROCLIENTE,    C_ETL.QTERROTOTAL,  
                       C_ETL.QTTOTALATIV      
                      );
       END LOOP;

       COMMIT;
       V_DTINI := ADD_MONTHS(V_DTINI,1);
    END LOOP;
END;
